﻿// Author: Ben
// Project: BlogMLSpamCommentRemover
// Path: C:\code\BlogMLSpamCommentRemover
// Creation date: 2009-10-25 7:05 PM
// Last modified: 2009-10-26 2:19 AM

#region Using directives
using Delta.Utilities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Xml.Linq;
#endregion

namespace BlogMLSpamCommentRemover
{
	/// <summary>
	/// Program
	/// </summary>
	class Program
	{
		/// <summary>
		/// Main
		/// </summary>
		static void Main(string[] args)
		{
			XDocument blogPosts = XDocument.Load("C:\\export.xml");
			int postsParsed = 0;
			int commentsParsed = 0;
			int trackbacksParsed = 0;
			int spamComments = 0;
			int spamTrackbacks = 0;
			foreach (XElement blogNode in blogPosts.Nodes())
			{
				Log.Info("blogNode: " + blogNode.Name.LocalName);
				foreach (XElement mainNode in blogNode.Nodes())
				{
					Log.Info("mainNode: " + mainNode.Name.LocalName);
					if (mainNode.Name.LocalName == "posts")
					{
						foreach (XElement post in mainNode.Nodes())
						{
							if (post.Value.Contains("For vs Foreach Performance"))
							{
								Log.Warning("Found problematic post");
							} // if
							postsParsed++;
							//Log.Info("Blog post: " + post.Name.LocalName);
								//XmlHelper.GetChildNode(post, "title").InnerText);
							// Now get all the comments
							foreach (XElement postNode in post.Nodes())
							{
								if (postNode.Name.LocalName == "comments")
								{
									List<XElement> remToRemoveComment = new List<XElement>();
									foreach (XElement comment in postNode.Nodes())
									{
										commentsParsed++;
										//Log.Info("\tComment: " + comment.Value);
										if (StringHelper.Contains(comment.Value,
											new string[]
										{
											"Spray foam insulation",
											"Could you help me. No one goes there nowadays, it's too crowded.",
											"Stock option program.",
											"best stock options",
											"The brain is a wonderful organ.",
											"Badly need your help.",
											"I wrote the following sentence:",
											"Looking for sites on:",
											"Could you help me.",
											"Just want to say i`m glad i found this site.",
											". Help me! ",
											"There is an urgent need for sites:",
											"Please help find sites for:",
											"Need information about:",
											"I find sites on the topic:",
											"I found only this -",
											"Help to find sites on the:",
											"Badly need your help.",
											"I can not find sites on the:",
											"Nice site - pity you have to go to such lengths to moderate it.",
											"learning to write in English,",
											"I wrote the following sentence:",
											"Need information about:",
											"Can not find sites on the:",
											"the only prayer you",
											"I find sites on the topic:",
											"Give me a deader bedbug",
											"alcoholic add-on.",
											"http://slyvici.livejournal.com",
											"http://www.narcononmsk.ru",
											"yourself in life as at a feast",
											"Steven Hudak bubble",
											"Applying spray foam insulation.",
											"Hares can gambol over the body of a dead lion.",
											"Help me! Need information about:",
											"You're dealing with the demon of external validation.",
											"I can not find sites on the:",
											"Looking for sites on:",
											"Our own physical body possesses",
											"I have the worst memory ever so no matter",
											"Our imagination is the only limit to what",
											"Please help find sites for:",
											"Nothing is particularly hard if you divide it into small jobs.",
										}))
										{
											Log.Warning("Found spam, removing it: " + comment.Value);
											// We can't directly remove here, else the foreach
											// won't continue :(
											remToRemoveComment.Add(comment);
											spamComments++;
										} // if
										else
										{
											Log.Info("Non-spam comment: " + comment.Value);
										} // else
									} // foreach

									// Now remove all remembered spam comments
									foreach (XElement removeComment in remToRemoveComment)
										removeComment.Remove();
								} // if
								else if (postNode.Name.LocalName == "trackbacks")
								{
									List<XElement> remToRemoveTrackbacks = new List<XElement>();
									foreach (XElement trackback in postNode.Nodes())
									{
										trackbacksParsed++;
										//Log.Info("\ttrackback: " + trackback.Value);
										if (StringHelper.Contains(trackback.Value,
											new string[]
										{
											// Do an inverse list, only keep trackbacks that sound
											// interesting!
											"XNA",
											"Development",
											"Programming",
											"Dungeon Quest",
											"Silverlight",
											"MSDN",
											"Xna",
											"Rocket Commander",
											"Racing Game",
											"ASP.NET",
										}) == false &&
											StringHelper.Contains(trackback.Attribute("url").Value,
											new string[]
										{
											// Same here, inverse list
											"exdream.com",
											"BenjaminNitschke",
											"blogs.msdn.com",
											"exdream.no-ip.info",
											"zbuffer",
											"ziggyware",
											"gamedev",
										}) == false)
										{
											Log.Warning("Found spam in trackback, removing it: " +
												trackback.Value);
											remToRemoveTrackbacks.Add(trackback);
											spamTrackbacks++;
										} // if
										else
										{
											Log.Info("Non-spam trackback: " + trackback.Value);
										} // else
									} // foreach

									// Now remove all remembered spam trackbacks
									foreach (XElement removeTrackback in remToRemoveTrackbacks)
										removeTrackback.Remove();
								} // else if
							} // foreach
						} // foreach
					} // if
				} // foreach
			} // foreach

			blogPosts.Save("C:\\exportCleaned.xml");

			Log.Info("Saved exportCleaned.xml! Parsed " +
				postsParsed + " posts with " +
				commentsParsed + " comments and " +
				trackbacksParsed + " trackbacks. Found and removed " +
				spamComments + " spam comments and " +
				spamTrackbacks + " spam trackbacks!");
		} // Main(args)
	} // class Program
} // namespace BlogMLSpamCommentRemover
